Качество кода
=============

Стандарт ISO/IEC 25010:2011 (ГОСТ Р ИСО/МЭК 25010-2015) определяет модель качества продукта, которая включает восемь характеристик верхнего уровня:

* функциональная пригодность;
* уровень производительности;
* совместимость;
* удобство использования (юзабилити);
* надёжность;
* защищённость;
* сопровождаемость;
* переносимость (мобильность).

В этом стандарте модель качества продукта (англ. software product quality model) рассматривается отдельно от субъективного качества в использовании, 
которое может сильно отличаться для различных стейкхолдеров.
Модель качества в использовании (англ. quality in use model) включает следующие характеристики верхнего уровня:

* результативность;
* производительность;
* удовлетворённость;
* свобода от риска;
* покрытие контекста.

Роберт Гласс в известной книге «Факты и заблуждения профессионального программирования» утверждает, 
что большинство профессиональных разработчиков согласны с выделением семи показателей качества как основных:

* переносимость;
* надёжность;
* эффективность;
* удобство использования (юзабилити);
* тестируемость;
* понятность;
* модифицируемость.

Среди относительно новых моделей качества программного обеспечения можно упомянуть SQUALE и Quamoco[11], 
которые были применены в промышленных условиях, но пока не получили широкого распространения. 

Для более полного понимания, рекомендуется прочитать книгу: 
**Совершенный код**, *Стив Макконнелл*.

Шпаргалка находится в [здесь](https://github.com/yii2guide/perfect-code/blob/master/guide/ru/README.md) (основные идеи из книги)
